<template>
  <div>
    <div class="content__top content__top--catalog">
      <h1 class="content__title">
        Каталог
      </h1>
      <span class="content__info">
      {{ items.length }} товара
    </span>
    </div>
    <div class="content__catalog">
      <item-filter :available-colors="availableColors" :filter-data.sync="filterData"/>
      <section class="catalog">
        <item-list :items="filteredItems"></item-list>
      </section>
    </div>
  </div>
</template>

<script>

import ItemList from '@/components/catalog/ItemList.vue';
import items from '@/data/items';
import ItemFilter from '@/components/catalog/ItemFilter.vue';

export default {
  name: 'Catalog',
  components: {
    ItemFilter,
    ItemList,
  },

  data() {
    return {
      items,
      filterData: {
        categoryId: 0,
        priceFrom: 0,
        priceTo: 0,
        color: null,
      },
    };
  },
  computed: {
    filteredItems() {
      let filtered = this.items;
      if (this.filterData.priceFrom > 0) {
        filtered = filtered.filter((it) => it.price > this.filterData.priceFrom);
      }
      if (this.filterData.priceTo > 0) {
        filtered = filtered.filter((it) => it.price < this.filterData.priceTo);
      }
      if (this.filterData.categoryId > 0) {
        filtered = filtered.filter((it) => it.category === this.filterData.categoryId);
      }
      if (this.filterData.color !== null) {
        filtered = filtered.filter((it) => it.colors.includes(this.filterData.color));
      }
      return filtered;
    },
    availableColors() {
      const colorsSet = new Set();
      items.forEach((it) => {
        it.colors.forEach((color) => colorsSet.add(color));
      });
      return Array.from(colorsSet);
    },
  },
};
</script>

<style scoped>

</style>
